diff --git a/drivers/cxl/core/mbox.c b/drivers/cxl/core/mbox.c
index 12758e763650..f464eb42f08a 100644
--- a/drivers/cxl/core/mbox.c
+++ b/drivers/cxl/core/mbox.c
@@ -118,6 +118,14 @@ static u8 security_command_sets[] = {
 	0x46, /* Security Passthrough */
 };
 
+#define FWCTL_CXL_MAX_COMMANDS 3
+/* Command set that is allowed with FWCTL-CXL */
+static u16 fwctl_command_sets[] = {
+	CXL_MBOX_OP_GET_SUPPORTED_FEATURES,
+	CXL_MBOX_OP_GET_FEATURE,
+	CXL_MBOX_OP_SET_FEATURE,
+};
+
 static bool cxl_is_security_command(u16 opcode)
 {
 	int i;
@@ -527,6 +535,44 @@ static int cxl_validate_cmd_from_user(struct cxl_mbox_cmd *mbox_cmd,
 				 send_cmd->in.payload);
 }
 
+static struct cxl_mem_command *
+fwctl_cxl_find_command(struct cxl_mailbox *cxl_mbox, u16 opcode)
+{
+	struct cxl_command_info *info;
+	struct cxl_mem_command *cmd;
+
+	cmd = cxl_mem_find_command(opcode);
+	if (!cmd)
+		return NULL;
+
+	info = &cmd->info;
+	if (test_bit(info->id, cxl_mbox->enabled_cmds) &&
+	    !test_bit(info->id, cxl_mbox->exclusive_cmds))
+		return cmd;
+
+	return NULL;
+}
+
+/**
+ * cxl_mailbox_user_commands_supported() - Return number of user mailbox
+ *                                         commands supported.
+ * @cxl_mbox: cxl mailbox context
+ *
+ * Return: number of commands supported
+ */
+int cxl_mailbox_user_commands_supported(struct cxl_mailbox *cxl_mbox)
+{
+	int nr_cmds = 0;
+
+	for (int i = 0; i < FWCTL_CXL_MAX_COMMANDS; i++) {
+		nr_cmds += !!fwctl_cxl_find_command(cxl_mbox,
+						    fwctl_command_sets[i]);
+	}
+
+	return nr_cmds;
+}
+EXPORT_SYMBOL_NS_GPL(cxl_mailbox_user_commands_supported, CXL);
+
 int cxl_query_cmd(struct cxl_mailbox *cxl_mbox,
 		  struct cxl_mem_query_commands __user *q)
 {
diff --git a/drivers/fwctl/cxl/cxl.c b/drivers/fwctl/cxl/cxl.c
index c6a11cbbd937..5eb5eabf2bff 100644
--- a/drivers/fwctl/cxl/cxl.c
+++ b/drivers/fwctl/cxl/cxl.c
@@ -6,6 +6,7 @@
 #include <linux/device.h>
 #include <cxl/cxl.h>
 #include <cxl/mailbox.h>
+#include <uapi/fwctl/cxl.h>
 
 struct cxlctl_uctx {
 	struct fwctl_uctx uctx;
@@ -21,6 +22,15 @@ DEFINE_FREE(cxlctl, struct cxlctl_dev *, if (_T) fwctl_put(&_T->fwctl))
 
 static int cxlctl_open_uctx(struct fwctl_uctx *uctx)
 {
+	struct cxlctl_uctx *cxlctl_uctx =
+		container_of(uctx, struct cxlctl_uctx, uctx);
+	struct fwctl_device *fwctl = uctx->fwctl;
+	struct cxlctl_dev *cxlctl =
+		container_of(fwctl, struct cxlctl_dev, fwctl);
+
+	cxlctl_uctx->nr_commands =
+		cxl_mailbox_user_commands_supported(cxlctl->mbox);
+
 	return 0;
 }
 
@@ -30,8 +40,17 @@ static void cxlctl_close_uctx(struct fwctl_uctx *uctx)
 
 static void *cxlctl_info(struct fwctl_uctx *uctx, size_t *length)
 {
-	/* Place holder */
-	return ERR_PTR(-EOPNOTSUPP);
+	struct cxlctl_uctx *cxlctl_uctx =
+		container_of(uctx, struct cxlctl_uctx, uctx);
+	struct fwctl_info_cxl *info;
+
+	info = kzalloc(sizeof(*info), GFP_KERNEL);
+	if (!info)
+		return ERR_PTR(-ENOMEM);
+
+	info->nr_commands = cxlctl_uctx->nr_commands;
+
+	return info;
 }
 
 static void *cxlctl_fw_rpc(struct fwctl_uctx *uctx, enum fwctl_rpc_scope scope,
diff --git a/include/cxl/cxl.h b/include/cxl/cxl.h
index 6bfd7942a3f7..d0939e3bcbc0 100644
--- a/include/cxl/cxl.h
+++ b/include/cxl/cxl.h
@@ -3,6 +3,8 @@
 #ifndef __CXL_GLOBAL_H__
 #define __CXL_GLOBAL_H__
 
+#include <linux/device.h>
+
 struct cxl_driver {
 	const char *name;
 	int (*probe)(struct device *dev);
diff --git a/include/cxl/mailbox.h b/include/cxl/mailbox.h
index 16d21f63464c..af01fb78ae10 100644
--- a/include/cxl/mailbox.h
+++ b/include/cxl/mailbox.h
@@ -84,5 +84,6 @@ struct cxl_mailbox {
 };
 
 int cxl_mailbox_init(struct cxl_mailbox *cxl_mbox, struct device *host);
+int cxl_mailbox_user_commands_supported(struct cxl_mailbox *cxl_mbox);
 
 #endif
diff --git a/include/uapi/fwctl/cxl.h b/include/uapi/fwctl/cxl.h
new file mode 100644
index 000000000000..a32c4c752db6
--- /dev/null
+++ b/include/uapi/fwctl/cxl.h
@@ -0,0 +1,22 @@
+/* SPDX-License-Identifier: GPL-2.0 WITH Linux-syscall-note */
+/*
+ * Copyright (c) 2024, Intel Corporation
+ *
+ * These are definitions for the mailbox command interface of CXL subsystem.
+ */
+#ifndef _UAPI_FWCTL_CXL_H_
+#define _UAPI_FWCTL_CXL_H_
+
+#include <linux/types.h>
+
+/**
+ * struct fwctl_info_cxl - ioctl(FWCTL_INFO) out_device_data
+ * @uctx_caps: The number of commands the driver and device supports
+ *
+ * Return basic information about the FW interface available.
+ */
+struct fwctl_info_cxl {
+	__u32 nr_commands;
+};
+
+#endif